### Hierarchy

- LoDashStatic

## Index

### Methods

- assign
- assignIn
- assignInWith
- assignWith
- at
- create
- defaults
- defaultsDeep
- entries
- entriesIn
- extend
- extendWith
- findKey
- findLastKey
- forIn
- forInRight
- forOwn
- forOwnRight
- functions
- functionsIn
- get
- has
- hasIn
- invert
- invertBy
- invoke
- keys
- keysIn
- mapKeys
- mapValues
- merge
- mergeWith
- omit
- omitBy
- pick
- pickBy
- result
- set
- setWith
- toPairs
- toPairsIn
- transform
- unset
- update
- updateWith
- values
- valuesIn

## Methods

### assign

- assign<TObject, TSource>(object: TObject, source: TSource): TObject & TSource
- assign<TObject, TSource1, TSource2>(object: TObject, source1: TSource1, source2: TSource2): TObject & TSource1 & TSource2
- assign<TObject, TSource1, TSource2, TSource3>(object: TObject, source1: TSource1, source2: TSource2, source3: TSource3): TObject & TSource1 & TSource2 & TSource3
- assign<TObject, TSource1, TSource2, TSource3, TSource4>(object: TObject, source1: TSource1, source2: TSource2, source3: TSource3, source4: TSource4): TObject & TSource1 & TSource2 & TSource3 & TSource4
- assign<TObject>(object: TObject): TObject
- assign(object: any, ...otherArgs: any[]): any

- - Defined in node_modules/@types/lodash/common/object.d.ts:34

  Assigns own enumerable properties of source objects to the destination object. Source objects are applied from left to right. Subsequent sources overwrite property assignments of previous sources.

  Note: This method mutates `object` and is loosely based on `Object.assign`.

  category

    Object

  example

    function Foo() { this.c = 3; }

    function Bar() { this.e = 5; }

    Foo.prototype.d = 4; Bar.prototype.f = 6;

    _.assign({ 'a': 1 }, new Foo, new Bar); // => { 'a': 1, 'c': 3, 'e': 5 }

  #### Type parameters

  - #### TObject

  - #### TSource

  #### Parameters

  - ##### object: TObject

    The destination object.

  - ##### source: TSource

  #### Returns TObject & TSource

  Returns `object`.

- - Defined in node_modules/@types/lodash/common/object.d.ts:42
  see

    assign

  #### Type parameters

  - #### TObject

  - #### TSource1

  - #### TSource2

  #### Parameters

  - ##### object: TObject

  - ##### source1: TSource1

  - ##### source2: TSource2

  #### Returns TObject & TSource1 & TSource2

- - Defined in node_modules/@types/lodash/common/object.d.ts:51
  see

    assign

  #### Type parameters

  - #### TObject

  - #### TSource1

  - #### TSource2

  - #### TSource3

  #### Parameters

  - ##### object: TObject

  - ##### source1: TSource1

  - ##### source2: TSource2

  - ##### source3: TSource3

  #### Returns TObject & TSource1 & TSource2 & TSource3

- - Defined in node_modules/@types/lodash/common/object.d.ts:61
  see

    assign

  #### Type parameters

  - #### TObject

  - #### TSource1

  - #### TSource2

  - #### TSource3

  - #### TSource4

  #### Parameters

  - ##### object: TObject

  - ##### source1: TSource1

  - ##### source2: TSource2

  - ##### source3: TSource3

  - ##### source4: TSource4

  #### Returns TObject & TSource1 & TSource2 & TSource3 & TSource4

- - Defined in node_modules/@types/lodash/common/object.d.ts:72
  see

    _.assign

  #### Type parameters

  - #### TObject

  #### Parameters

  - ##### object: TObject

  #### Returns TObject

- - Defined in node_modules/@types/lodash/common/object.d.ts:77
  see

    _.assign

  #### Parameters

  - ##### object: any

  - ##### Rest ...otherArgs: any[]

  #### Returns any

### assignIn

- assignIn<TObject, TSource>(object: TObject, source: TSource): TObject & TSource
- assignIn<TObject, TSource1, TSource2>(object: TObject, source1: TSource1, source2: TSource2): TObject & TSource1 & TSource2
- assignIn<TObject, TSource1, TSource2, TSource3>(object: TObject, source1: TSource1, source2: TSource2, source3: TSource3): TObject & TSource1 & TSource2 & TSource3
- assignIn<TObject, TSource1, TSource2, TSource3, TSource4>(object: TObject, source1: TSource1, source2: TSource2, source3: TSource3, source4: TSource4): TObject & TSource1 & TSource2 & TSource3 & TSource4
- assignIn<TObject>(object: TObject): TObject
- assignIn<TResult>(object: any, ...otherArgs: any[]): TResult

- - Defined in node_modules/@types/lodash/common/object.d.ts:205

  This method is like `_.assign` except that it iterates over own and inherited source properties.

  Note: This method mutates `object`.

  alias

    extend

  category

    Object

  example

    function Foo() { this.b = 2; }

    function Bar() { this.d = 4; }

    Foo.prototype.c = 3; Bar.prototype.e = 5;

    _.assignIn({ 'a': 1 }, new Foo, new Bar); // => { 'a': 1, 'b': 2, 'c': 3, 'd': 4, 'e': 5 }

  #### Type parameters

  - #### TObject

  - #### TSource

  #### Parameters

  - ##### object: TObject

    The destination object.

  - ##### source: TSource

  #### Returns TObject & TSource

  Returns `object`.

- - Defined in node_modules/@types/lodash/common/object.d.ts:213
  see

    assignIn

  #### Type parameters

  - #### TObject

  - #### TSource1

  - #### TSource2

  #### Parameters

  - ##### object: TObject

  - ##### source1: TSource1

  - ##### source2: TSource2

  #### Returns TObject & TSource1 & TSource2

- - Defined in node_modules/@types/lodash/common/object.d.ts:222
  see

    assignIn

  #### Type parameters

  - #### TObject

  - #### TSource1

  - #### TSource2

  - #### TSource3

  #### Parameters

  - ##### object: TObject

  - ##### source1: TSource1

  - ##### source2: TSource2

  - ##### source3: TSource3

  #### Returns TObject & TSource1 & TSource2 & TSource3

- - Defined in node_modules/@types/lodash/common/object.d.ts:232
  see

    assignIn

  #### Type parameters

  - #### TObject

  - #### TSource1

  - #### TSource2

  - #### TSource3

  - #### TSource4

  #### Parameters

  - ##### object: TObject

  - ##### source1: TSource1

  - ##### source2: TSource2

  - ##### source3: TSource3

  - ##### source4: TSource4

  #### Returns TObject & TSource1 & TSource2 & TSource3 & TSource4

- - Defined in node_modules/@types/lodash/common/object.d.ts:243
  see

    _.assignIn

  #### Type parameters

  - #### TObject

  #### Parameters

  - ##### object: TObject

  #### Returns TObject

- - Defined in node_modules/@types/lodash/common/object.d.ts:248
  see

    _.assignIn

  #### Type parameters

  - #### TResult

  #### Parameters

  - ##### object: any

  - ##### Rest ...otherArgs: any[]

  #### Returns TResult

### assignInWith

- assignInWith<TObject, TSource>(object: TObject, source: TSource, customizer: AssignCustomizer): TObject & TSource
- assignInWith<TObject, TSource1, TSource2>(object: TObject, source1: TSource1, source2: TSource2, customizer: AssignCustomizer): TObject & TSource1 & TSource2
- assignInWith<TObject, TSource1, TSource2, TSource3>(object: TObject, source1: TSource1, source2: TSource2, source3: TSource3, customizer: AssignCustomizer): TObject & TSource1 & TSource2 & TSource3
- assignInWith<TObject, TSource1, TSource2, TSource3, TSource4>(object: TObject, source1: TSource1, source2: TSource2, source3: TSource3, source4: TSource4, customizer: AssignCustomizer): TObject & TSource1 & TSource2 & TSource3 & TSource4
- assignInWith<TObject>(object: TObject): TObject
- assignInWith<TResult>(object: any, ...otherArgs: any[]): TResult

- - Defined in node_modules/@types/lodash/common/object.d.ts:376

  This method is like `_.assignIn` except that it accepts `customizer` which is invoked to produce the assigned values. If `customizer` returns `undefined` assignment is handled by the method instead. The `customizer` is invoked with five arguments: (objValue, srcValue, key, object, source).

  Note: This method mutates `object`.

  alias

    extendWith

  category

    Object

  example

    function customizer(objValue, srcValue) { return _.isUndefined(objValue) ? srcValue : objValue; }

    var defaults = .partialRight(.assignInWith, customizer);

    defaults({ 'a': 1 }, { 'b': 2 }, { 'a': 3 }); // => { 'a': 1, 'b': 2 }

  #### Type parameters

  - #### TObject

  - #### TSource

  #### Parameters

  - ##### object: TObject

    The destination object.

  - ##### source: TSource

  - ##### customizer: AssignCustomizer

  #### Returns TObject & TSource

  Returns `object`.

- - Defined in node_modules/@types/lodash/common/object.d.ts:385
  see

    assignInWith

  #### Type parameters

  - #### TObject

  - #### TSource1

  - #### TSource2

  #### Parameters

  - ##### object: TObject

  - ##### source1: TSource1

  - ##### source2: TSource2

  - ##### customizer: AssignCustomizer

  #### Returns TObject & TSource1 & TSource2

- - Defined in node_modules/@types/lodash/common/object.d.ts:395
  see

    assignInWith

  #### Type parameters

  - #### TObject

  - #### TSource1

  - #### TSource2

  - #### TSource3

  #### Parameters

  - ##### object: TObject

  - ##### source1: TSource1

  - ##### source2: TSource2

  - ##### source3: TSource3

  - ##### customizer: AssignCustomizer

  #### Returns TObject & TSource1 & TSource2 & TSource3

- - Defined in node_modules/@types/lodash/common/object.d.ts:406
  see

    assignInWith

  #### Type parameters

  - #### TObject

  - #### TSource1

  - #### TSource2

  - #### TSource3

  - #### TSource4

  #### Parameters

  - ##### object: TObject

  - ##### source1: TSource1

  - ##### source2: TSource2

  - ##### source3: TSource3

  - ##### source4: TSource4

  - ##### customizer: AssignCustomizer

  #### Returns TObject & TSource1 & TSource2 & TSource3 & TSource4

- - Defined in node_modules/@types/lodash/common/object.d.ts:418
  see

    _.assignInWith

  #### Type parameters

  - #### TObject

  #### Parameters

  - ##### object: TObject

  #### Returns TObject

- - Defined in node_modules/@types/lodash/common/object.d.ts:423
  see

    _.assignInWith

  #### Type parameters

  - #### TResult

  #### Parameters

  - ##### object: any

  - ##### Rest ...otherArgs: any[]

  #### Returns TResult

### assignWith

- assignWith<TObject, TSource>(object: TObject, source: TSource, customizer: AssignCustomizer): TObject & TSource
- assignWith<TObject, TSource1, TSource2>(object: TObject, source1: TSource1, source2: TSource2, customizer: AssignCustomizer): TObject & TSource1 & TSource2
- assignWith<TObject, TSource1, TSource2, TSource3>(object: TObject, source1: TSource1, source2: TSource2, source3: TSource3, customizer: AssignCustomizer): TObject & TSource1 & TSource2 & TSource3
- assignWith<TObject, TSource1, TSource2, TSource3, TSource4>(object: TObject, source1: TSource1, source2: TSource2, source3: TSource3, source4: TSource4, customizer: AssignCustomizer): TObject & TSource1 & TSource2 & TSource3 & TSource4
- assignWith<TObject>(object: TObject): TObject
- assignWith<TResult>(object: any, ...otherArgs: any[]): TResult

- - Defined in node_modules/@types/lodash/common/object.d.ts:556

  This method is like `_.assign` except that it accepts `customizer` which is invoked to produce the assigned values. If `customizer` returns `undefined` assignment is handled by the method instead. The `customizer` is invoked with five arguments: (objValue, srcValue, key, object, source).

  Note: This method mutates `object`.

  category

    Object

  example

    function customizer(objValue, srcValue) { return _.isUndefined(objValue) ? srcValue : objValue; }

    var defaults = .partialRight(.assignWith, customizer);

    defaults({ 'a': 1 }, { 'b': 2 }, { 'a': 3 }); // => { 'a': 1, 'b': 2 }

  #### Type parameters

  - #### TObject

  - #### TSource

  #### Parameters

  - ##### object: TObject

    The destination object.

  - ##### source: TSource

  - ##### customizer: AssignCustomizer

  #### Returns TObject & TSource

  Returns `object`.

- - Defined in node_modules/@types/lodash/common/object.d.ts:565
  see

    assignWith

  #### Type parameters

  - #### TObject

  - #### TSource1

  - #### TSource2

  #### Parameters

  - ##### object: TObject

  - ##### source1: TSource1

  - ##### source2: TSource2

  - ##### customizer: AssignCustomizer

  #### Returns TObject & TSource1 & TSource2

- - Defined in node_modules/@types/lodash/common/object.d.ts:575
  see

    assignWith

  #### Type parameters

  - #### TObject

  - #### TSource1

  - #### TSource2

  - #### TSource3

  #### Parameters

  - ##### object: TObject

  - ##### source1: TSource1

  - ##### source2: TSource2

  - ##### source3: TSource3

  - ##### customizer: AssignCustomizer

  #### Returns TObject & TSource1 & TSource2 & TSource3

- - Defined in node_modules/@types/lodash/common/object.d.ts:586
  see

    assignWith

  #### Type parameters

  - #### TObject

  - #### TSource1

  - #### TSource2

  - #### TSource3

  - #### TSource4

  #### Parameters

  - ##### object: TObject

  - ##### source1: TSource1

  - ##### source2: TSource2

  - ##### source3: TSource3

  - ##### source4: TSource4

  - ##### customizer: AssignCustomizer

  #### Returns TObject & TSource1 & TSource2 & TSource3 & TSource4

- - Defined in node_modules/@types/lodash/common/object.d.ts:598
  see

    _.assignWith

  #### Type parameters

  - #### TObject

  #### Parameters

  - ##### object: TObject

  #### Returns TObject

- - Defined in node_modules/@types/lodash/common/object.d.ts:603
  see

    _.assignWith

  #### Type parameters

  - #### TResult

  #### Parameters

  - ##### object: any

  - ##### Rest ...otherArgs: any[]

  #### Returns TResult

### at

- at<T>(object: List<T> | Dictionary<T> | NumericDictionary<T> | null | undefined, ...props: PropertyPath[]): T[]
- at<T>(object: T | null | undefined, ...props: Array<Many<keyof T>>): Array<T[keyof T]>

- - Defined in node_modules/@types/lodash/common/object.d.ts:720

  Creates an array of elements corresponding to the given keys, or indexes, of collection. Keys may be specified as individual arguments or as arrays of keys.

  #### Type parameters

  - #### T

  #### Parameters

  - ##### object: List<T> | Dictionary<T> | NumericDictionary<T> | null | undefined

    The object to iterate over.

  - ##### Rest ...props: PropertyPath[]

    The property names or indexes of elements to pick, specified individually or in arrays.

  #### Returns T[]

  Returns the new array of picked elements.

- - Defined in node_modules/@types/lodash/common/object.d.ts:728
  see

    _.at

  #### Type parameters

  - #### T: object

  #### Parameters

  - ##### object: T | null | undefined

  - ##### Rest ...props: Array<Many<keyof T>>

  #### Returns Array<T[keyof T]>

### create

- create<T, U>(prototype: T, properties?: U): T & U

- - Defined in node_modules/@types/lodash/common/object.d.ts:781

  Creates an object that inherits from the given prototype object. If a properties object is provided its own enumerable properties are assigned to the created object.

  #### Type parameters

  - #### T: object

  - #### U: object

  #### Parameters

  - ##### prototype: T

    The object to inherit from.

  - ##### Optional properties: U

    The properties to assign to the object.

  #### Returns T & U

  Returns the new object.

### defaults

- defaults<TObject, TSource>(object: TObject, source: TSource): TSource & TObject
- defaults<TObject, TSource1, TSource2>(object: TObject, source1: TSource1, source2: TSource2): TSource2 & TSource1 & TObject
- defaults<TObject, TSource1, TSource2, TSource3>(object: TObject, source1: TSource1, source2: TSource2, source3: TSource3): TSource3 & TSource2 & TSource1 & TObject
- defaults<TObject, TSource1, TSource2, TSource3, TSource4>(object: TObject, source1: TSource1, source2: TSource2, source3: TSource3, source4: TSource4): TSource4 & TSource3 & TSource2 & TSource1 & TObject
- defaults<TObject>(object: TObject): TObject
- defaults(object: any, ...sources: any[]): any

- - Defined in node_modules/@types/lodash/common/object.d.ts:815

  Assigns own enumerable properties of source object(s) to the destination object for all destination properties that resolve to undefined. Once a property is set, additional values of the same property are ignored.

  Note: This method mutates object.

  #### Type parameters

  - #### TObject

  - #### TSource

  #### Parameters

  - ##### object: TObject

    The destination object.

  - ##### source: TSource

  #### Returns TSource & TObject

  The destination object.

- - Defined in node_modules/@types/lodash/common/object.d.ts:823
  see

    _.defaults

  #### Type parameters

  - #### TObject

  - #### TSource1

  - #### TSource2

  #### Parameters

  - ##### object: TObject

  - ##### source1: TSource1

  - ##### source2: TSource2

  #### Returns TSource2 & TSource1 & TObject

- - Defined in node_modules/@types/lodash/common/object.d.ts:832
  see

    _.defaults

  #### Type parameters

  - #### TObject

  - #### TSource1

  - #### TSource2

  - #### TSource3

  #### Parameters

  - ##### object: TObject

  - ##### source1: TSource1

  - ##### source2: TSource2

  - ##### source3: TSource3

  #### Returns TSource3 & TSource2 & TSource1 & TObject

- - Defined in node_modules/@types/lodash/common/object.d.ts:842
  see

    _.defaults

  #### Type parameters

  - #### TObject

  - #### TSource1

  - #### TSource2

  - #### TSource3

  - #### TSource4

  #### Parameters

  - ##### object: TObject

  - ##### source1: TSource1

  - ##### source2: TSource2

  - ##### source3: TSource3

  - ##### source4: TSource4

  #### Returns TSource4 & TSource3 & TSource2 & TSource1 & TObject

- - Defined in node_modules/@types/lodash/common/object.d.ts:853
  see

    _.defaults

  #### Type parameters

  - #### TObject

  #### Parameters

  - ##### object: TObject

  #### Returns TObject

- - Defined in node_modules/@types/lodash/common/object.d.ts:858
  see

    _.defaults

  #### Parameters

  - ##### object: any

  - ##### Rest ...sources: any[]

  #### Returns any

### defaultsDeep

- defaultsDeep(object: any, ...sources: any[]): any

- - Defined in node_modules/@types/lodash/common/object.d.ts:965

  This method is like _.defaults except that it recursively assigns default properties.

  #### Parameters

  - ##### object: any

    The destination object.

  - ##### Rest ...sources: any[]

    The source objects.

  #### Returns any

  Returns object.

### entries

- entries<T>(object?: Dictionary<T> | NumericDictionary<T>): Array<[string, T]>
- entries(object?: undefined | object): Array<[string, any]>

- - Defined in node_modules/@types/lodash/common/object.d.ts:990
  see

    _.toPairs

  #### Type parameters

  - #### T

  #### Parameters

  - ##### Optional object: Dictionary<T> | NumericDictionary<T>

  #### Returns Array<[string, T]>

- - Defined in node_modules/@types/lodash/common/object.d.ts:995
  see

    _.toPairs

  #### Parameters

  - ##### Optional object: undefined | object

  #### Returns Array<[string, any]>

### entriesIn

- entriesIn<T>(object?: Dictionary<T> | NumericDictionary<T>): Array<[string, T]>
- entriesIn(object?: undefined | object): Array<[string, any]>

- - Defined in node_modules/@types/lodash/common/object.d.ts:1028
  see

    _.entriesIn

  #### Type parameters

  - #### T

  #### Parameters

  - ##### Optional object: Dictionary<T> | NumericDictionary<T>

  #### Returns Array<[string, T]>

- - Defined in node_modules/@types/lodash/common/object.d.ts:1033
  see

    _.entriesIn

  #### Parameters

  - ##### Optional object: undefined | object

  #### Returns Array<[string, any]>

### extend

- extend<TObject, TSource>(object: TObject, source: TSource): TObject & TSource
- extend<TObject, TSource1, TSource2>(object: TObject, source1: TSource1, source2: TSource2): TObject & TSource1 & TSource2
- extend<TObject, TSource1, TSource2, TSource3>(object: TObject, source1: TSource1, source2: TSource2, source3: TSource3): TObject & TSource1 & TSource2 & TSource3
- extend<TObject, TSource1, TSource2, TSource3, TSource4>(object: TObject, source1: TSource1, source2: TSource2, source3: TSource3, source4: TSource4): TObject & TSource1 & TSource2 & TSource3 & TSource4
- extend<TObject>(object: TObject): TObject
- extend<TResult>(object: any, ...otherArgs: any[]): TResult

- - Defined in node_modules/@types/lodash/common/object.d.ts:1066
  see

    _.extend

  #### Type parameters

  - #### TObject

  - #### TSource

  #### Parameters

  - ##### object: TObject

  - ##### source: TSource

  #### Returns TObject & TSource

- - Defined in node_modules/@types/lodash/common/object.d.ts:1074
  see

    _.extend

  #### Type parameters

  - #### TObject

  - #### TSource1

  - #### TSource2

  #### Parameters

  - ##### object: TObject

  - ##### source1: TSource1

  - ##### source2: TSource2

  #### Returns TObject & TSource1 & TSource2

- - Defined in node_modules/@types/lodash/common/object.d.ts:1083
  see

    _.extend

  #### Type parameters

  - #### TObject

  - #### TSource1

  - #### TSource2

  - #### TSource3

  #### Parameters

  - ##### object: TObject

  - ##### source1: TSource1

  - ##### source2: TSource2

  - ##### source3: TSource3

  #### Returns TObject & TSource1 & TSource2 & TSource3

- - Defined in node_modules/@types/lodash/common/object.d.ts:1093
  see

    _.extend

  #### Type parameters

  - #### TObject

  - #### TSource1

  - #### TSource2

  - #### TSource3

  - #### TSource4

  #### Parameters

  - ##### object: TObject

  - ##### source1: TSource1

  - ##### source2: TSource2

  - ##### source3: TSource3

  - ##### source4: TSource4

  #### Returns TObject & TSource1 & TSource2 & TSource3 & TSource4

- - Defined in node_modules/@types/lodash/common/object.d.ts:1104
  see

    _.extend

  #### Type parameters

  - #### TObject

  #### Parameters

  - ##### object: TObject

  #### Returns TObject

- - Defined in node_modules/@types/lodash/common/object.d.ts:1109
  see

    _.extend

  #### Type parameters

  - #### TResult

  #### Parameters

  - ##### object: any

  - ##### Rest ...otherArgs: any[]

  #### Returns TResult

### extendWith

- extendWith<TObject, TSource>(object: TObject, source: TSource, customizer: AssignCustomizer): TObject & TSource
- extendWith<TObject, TSource1, TSource2>(object: TObject, source1: TSource1, source2: TSource2, customizer: AssignCustomizer): TObject & TSource1 & TSource2
- extendWith<TObject, TSource1, TSource2, TSource3>(object: TObject, source1: TSource1, source2: TSource2, source3: TSource3, customizer: AssignCustomizer): TObject & TSource1 & TSource2 & TSource3
- extendWith<TObject, TSource1, TSource2, TSource3, TSource4>(object: TObject, source1: TSource1, source2: TSource2, source3: TSource3, source4: TSource4, customizer: AssignCustomizer): TObject & TSource1 & TSource2 & TSource3 & TSource4
- extendWith<TObject>(object: TObject): TObject
- extendWith<TResult>(object: any, ...otherArgs: any[]): TResult

- - Defined in node_modules/@types/lodash/common/object.d.ts:1213
  see

    _.extendWith

  #### Type parameters

  - #### TObject

  - #### TSource

  #### Parameters

  - ##### object: TObject

  - ##### source: TSource

  - ##### customizer: AssignCustomizer

  #### Returns TObject & TSource

- - Defined in node_modules/@types/lodash/common/object.d.ts:1222
  see

    _.extendWith

  #### Type parameters

  - #### TObject

  - #### TSource1

  - #### TSource2

  #### Parameters

  - ##### object: TObject

  - ##### source1: TSource1

  - ##### source2: TSource2

  - ##### customizer: AssignCustomizer

  #### Returns TObject & TSource1 & TSource2

- - Defined in node_modules/@types/lodash/common/object.d.ts:1232
  see

    _.extendWith

  #### Type parameters

  - #### TObject

  - #### TSource1

  - #### TSource2

  - #### TSource3

  #### Parameters

  - ##### object: TObject

  - ##### source1: TSource1

  - ##### source2: TSource2

  - ##### source3: TSource3

  - ##### customizer: AssignCustomizer

  #### Returns TObject & TSource1 & TSource2 & TSource3

- - Defined in node_modules/@types/lodash/common/object.d.ts:1243
  see

    _.extendWith

  #### Type parameters

  - #### TObject

  - #### TSource1

  - #### TSource2

  - #### TSource3

  - #### TSource4

  #### Parameters

  - ##### object: TObject

  - ##### source1: TSource1

  - ##### source2: TSource2

  - ##### source3: TSource3

  - ##### source4: TSource4

  - ##### customizer: AssignCustomizer

  #### Returns TObject & TSource1 & TSource2 & TSource3 & TSource4

- - Defined in node_modules/@types/lodash/common/object.d.ts:1255
  see

    _.extendWith

  #### Type parameters

  - #### TObject

  #### Parameters

  - ##### object: TObject

  #### Returns TObject

- - Defined in node_modules/@types/lodash/common/object.d.ts:1260
  see

    _.extendWith

  #### Type parameters

  - #### TResult

  #### Parameters

  - ##### object: any

  - ##### Rest ...otherArgs: any[]

  #### Returns TResult

### findKey

- findKey<T>(object: T | null | undefined, predicate?: ObjectIteratee<T>): string | undefined

- - Defined in node_modules/@types/lodash/common/object.d.ts:1377

  This method is like _.find except that it returns the key of the first element predicate returns truthy for instead of the element itself.

  #### Type parameters

  - #### T

  #### Parameters

  - ##### object: T | null | undefined

    The object to search.

  - ##### Optional predicate: ObjectIteratee<T>

    The function invoked per iteration.

  #### Returns string | undefined

  Returns the key of the matched element, else undefined.

### findLastKey

- findLastKey<T>(object: T | null | undefined, predicate?: ObjectIteratee<T>): string | undefined

- - Defined in node_modules/@types/lodash/common/object.d.ts:1413

  This method is like _.findKey except that it iterates over elements of a collection in the opposite order.

  #### Type parameters

  - #### T

  #### Parameters

  - ##### object: T | null | undefined

    The object to search.

  - ##### Optional predicate: ObjectIteratee<T>

    The function invoked per iteration.

  #### Returns string | undefined

  Returns the key of the matched element, else undefined.

### forIn

- forIn<T>(object: T, iteratee?: ObjectIterator<T, any>): T
- forIn<T>(object: T | null | undefined, iteratee?: ObjectIterator<T, any>): T | null | undefined

- - Defined in node_modules/@types/lodash/common/object.d.ts:1451

  Iterates over own and inherited enumerable properties of an object invoking iteratee for each property. The iteratee is invoked with three arguments: (value, key, object). Iteratee functions may exit iteration early by explicitly returning false.

  #### Type parameters

  - #### T

  #### Parameters

  - ##### object: T

    The object to iterate over.

  - ##### Optional iteratee: ObjectIterator<T, any>

    The function invoked per iteration.

  #### Returns T

  Returns object.

- - Defined in node_modules/@types/lodash/common/object.d.ts:1459
  see

    _.forIn

  #### Type parameters

  - #### T

  #### Parameters

  - ##### object: T | null | undefined

  - ##### Optional iteratee: ObjectIterator<T, any>

  #### Returns T | null | undefined

### forInRight

- forInRight<T>(object: T, iteratee?: ObjectIterator<T, any>): T
- forInRight<T>(object: T | null | undefined, iteratee?: ObjectIterator<T, any>): T | null | undefined

- - Defined in node_modules/@types/lodash/common/object.d.ts:1485

  This method is like _.forIn except that it iterates over properties of object in the opposite order.

  #### Type parameters

  - #### T

  #### Parameters

  - ##### object: T

    The object to iterate over.

  - ##### Optional iteratee: ObjectIterator<T, any>

    The function invoked per iteration.

  #### Returns T

  Returns object.

- - Defined in node_modules/@types/lodash/common/object.d.ts:1493
  see

    _.forInRight

  #### Type parameters

  - #### T

  #### Parameters

  - ##### object: T | null | undefined

  - ##### Optional iteratee: ObjectIterator<T, any>

  #### Returns T | null | undefined

### forOwn

- forOwn<T>(object: T, iteratee?: ObjectIterator<T, any>): T
- forOwn<T>(object: T | null | undefined, iteratee?: ObjectIterator<T, any>): T | null | undefined

- - Defined in node_modules/@types/lodash/common/object.d.ts:1521

  Iterates over own enumerable properties of an object invoking iteratee for each property. The iteratee is invoked with three arguments: (value, key, object). Iteratee functions may exit iteration early by explicitly returning false.

  #### Type parameters

  - #### T

  #### Parameters

  - ##### object: T

    The object to iterate over.

  - ##### Optional iteratee: ObjectIterator<T, any>

    The function invoked per iteration.

  #### Returns T

  Returns object.

- - Defined in node_modules/@types/lodash/common/object.d.ts:1529
  see

    _.forOwn

  #### Type parameters

  - #### T

  #### Parameters

  - ##### object: T | null | undefined

  - ##### Optional iteratee: ObjectIterator<T, any>

  #### Returns T | null | undefined

### forOwnRight

- forOwnRight<T>(object: T, iteratee?: ObjectIterator<T, any>): T
- forOwnRight<T>(object: T | null | undefined, iteratee?: ObjectIterator<T, any>): T | null | undefined

- - Defined in node_modules/@types/lodash/common/object.d.ts:1555

  This method is like _.forOwn except that it iterates over properties of object in the opposite order.

  #### Type parameters

  - #### T

  #### Parameters

  - ##### object: T

    The object to iterate over.

  - ##### Optional iteratee: ObjectIterator<T, any>

    The function invoked per iteration.

  #### Returns T

  Returns object.

- - Defined in node_modules/@types/lodash/common/object.d.ts:1563
  see

    _.forOwnRight

  #### Type parameters

  - #### T

  #### Parameters

  - ##### object: T | null | undefined

  - ##### Optional iteratee: ObjectIterator<T, any>

  #### Returns T | null | undefined

### functions

- functions(object: any): string[]

- - Defined in node_modules/@types/lodash/common/object.d.ts:1601

  Creates an array of function property names from own enumerable properties of `object`.

  category

    Object

  example

    function Foo() { this.a = _.constant('a'); this.b = _.constant('b'); }

    Foo.prototype.c = _.constant('c');

    _.functions(new Foo); // => ['a', 'b']

  #### Parameters

  - ##### object: any

    The object to inspect.

  #### Returns string[]

  Returns the new array of property names.

### functionsIn

- functionsIn<T>(object: any): string[]

- - Defined in node_modules/@types/lodash/common/object.d.ts:1640

  Creates an array of function property names from own and inherited enumerable properties of `object`.

  category

    Object

  example

    function Foo() { this.a = _.constant('a'); this.b = _.constant('b'); }

    Foo.prototype.c = _.constant('c');

    _.functionsIn(new Foo); // => ['a', 'b', 'c']

  #### Type parameters

  - #### T: __type

  #### Parameters

  - ##### object: any

    The object to inspect.

  #### Returns string[]

  Returns the new array of property names.

### get

- get<TObject, TKey>(object: TObject, path: TKey | [TKey]): TObject[TKey]
- get<TObject, TKey>(object: TObject | null | undefined, path: TKey | [TKey]): TObject[TKey] | undefined
- get<TObject, TKey, TDefault>(object: TObject | null | undefined, path: TKey | [TKey], defaultValue: TDefault): TObject[TKey] | TDefault
- get<T>(object: NumericDictionary<T>, path: number): T
- get<T>(object: NumericDictionary<T> | null | undefined, path: number): T | undefined
- get<T, TDefault>(object: NumericDictionary<T> | null | undefined, path: number, defaultValue: TDefault): T | TDefault
- get<TDefault>(object: null | undefined, path: PropertyPath, defaultValue: TDefault): TDefault
- get(object: null | undefined, path: PropertyPath): undefined
- get(object: any, path: PropertyPath, defaultValue?: any): any

- - Defined in node_modules/@types/lodash/common/object.d.ts:1669

  Gets the property value at path of object. If the resolved value is undefined the defaultValue is used in its place.

  #### Type parameters

  - #### TObject: object

  - #### TKey: keyof TObject

  #### Parameters

  - ##### object: TObject

    The object to query.

  - ##### path: TKey | [TKey]

    The path of the property to get.

  #### Returns TObject[TKey]

  Returns the resolved value.

- - Defined in node_modules/@types/lodash/common/object.d.ts:1677
  see

    _.get

  #### Type parameters

  - #### TObject: object

  - #### TKey: keyof TObject

  #### Parameters

  - ##### object: TObject | null | undefined

  - ##### path: TKey | [TKey]

  #### Returns TObject[TKey] | undefined

- - Defined in node_modules/@types/lodash/common/object.d.ts:1685
  see

    _.get

  #### Type parameters

  - #### TObject: object

  - #### TKey: keyof TObject

  - #### TDefault

  #### Parameters

  - ##### object: TObject | null | undefined

  - ##### path: TKey | [TKey]

  - ##### defaultValue: TDefault

  #### Returns TObject[TKey] | TDefault

- - Defined in node_modules/@types/lodash/common/object.d.ts:1694
  see

    _.get

  #### Type parameters

  - #### T

  #### Parameters

  - ##### object: NumericDictionary<T>

  - ##### path: number

  #### Returns T

- - Defined in node_modules/@types/lodash/common/object.d.ts:1702
  see

    _.get

  #### Type parameters

  - #### T

  #### Parameters

  - ##### object: NumericDictionary<T> | null | undefined

  - ##### path: number

  #### Returns T | undefined

- - Defined in node_modules/@types/lodash/common/object.d.ts:1710
  see

    _.get

  #### Type parameters

  - #### T

  - #### TDefault

  #### Parameters

  - ##### object: NumericDictionary<T> | null | undefined

  - ##### path: number

  - ##### defaultValue: TDefault

  #### Returns T | TDefault

- - Defined in node_modules/@types/lodash/common/object.d.ts:1719
  see

    _.get

  #### Type parameters

  - #### TDefault

  #### Parameters

  - ##### object: null | undefined

  - ##### path: PropertyPath

  - ##### defaultValue: TDefault

  #### Returns TDefault

- - Defined in node_modules/@types/lodash/common/object.d.ts:1728
  see

    _.get

  #### Parameters

  - ##### object: null | undefined

  - ##### path: PropertyPath

  #### Returns undefined

- - Defined in node_modules/@types/lodash/common/object.d.ts:1736
  see

    _.get

  #### Parameters

  - ##### object: any

  - ##### path: PropertyPath

  - ##### Optional defaultValue: any

  #### Returns any

### has

- has<T>(object: T, path: PropertyPath): boolean

- - Defined in node_modules/@types/lodash/common/object.d.ts:1922

  Checks if `path` is a direct property of `object`.

  category

    Object

  example

    var object = { 'a': { 'b': { 'c': 3 } } }; var other = _.create({ 'a': _.create({ 'b': _.create({ 'c': 3 }) }) });

    _.has(object, 'a'); // => true

    _.has(object, 'a.b.c'); // => true

    _.has(object, ['a', 'b', 'c']); // => true

    _.has(other, 'a'); // => false

  #### Type parameters

  - #### T

  #### Parameters

  - ##### object: T

    The object to query.

  - ##### path: PropertyPath

    The path to check.

  #### Returns boolean

  Returns `true` if `path` exists, else `false`.

### hasIn

- hasIn<T>(object: T, path: PropertyPath): boolean

- - Defined in node_modules/@types/lodash/common/object.d.ts:1968

  Checks if `path` is a direct or inherited property of `object`.

  category

    Object

  example

    var object = _.create({ 'a': _.create({ 'b': _.create({ 'c': 3 }) }) });

    _.hasIn(object, 'a'); // => true

    _.hasIn(object, 'a.b.c'); // => true

    _.hasIn(object, ['a', 'b', 'c']); // => true

    _.hasIn(object, 'b'); // => false

  #### Type parameters

  - #### T

  #### Parameters

  - ##### object: T

    The object to query.

  - ##### path: PropertyPath

    The path to check.

  #### Returns boolean

  Returns `true` if `path` exists, else `false`.

### invert

- invert(object: object): Dictionary<string>

- - Defined in node_modules/@types/lodash/common/object.d.ts:1999

  Creates an object composed of the inverted keys and values of object. If object contains duplicate values, subsequent values overwrite property assignments of previous values unless multiValue is true.

  #### Parameters

  - ##### object: object

    The object to invert.

  #### Returns Dictionary<string>

  Returns the new inverted object.

### invertBy

- invertBy<T>(object: List<T> | Dictionary<T> | NumericDictionary<T> | null | undefined, interatee?: ValueIteratee<T>): Dictionary<string[]>
- invertBy<T>(object: T | null | undefined, interatee?: ValueIteratee<T[keyof T]>): Dictionary<string[]>

- - Defined in node_modules/@types/lodash/common/object.d.ts:2030

  This method is like _.invert except that the inverted object is generated from the results of running each element of object through iteratee. The corresponding inverted value of each inverted key is an array of keys responsible for generating the inverted value. The iteratee is invoked with one argument: (value).

  #### Type parameters

  - #### T

  #### Parameters

  - ##### object: List<T> | Dictionary<T> | NumericDictionary<T> | null | undefined

    The object to invert.

  - ##### Optional interatee: ValueIteratee<T>

    The iteratee invoked per element.

  #### Returns Dictionary<string[]>

  Returns the new inverted object.

- - Defined in node_modules/@types/lodash/common/object.d.ts:2038
  see

    _.invertBy

  #### Type parameters

  - #### T: object

  #### Parameters

  - ##### object: T | null | undefined

  - ##### Optional interatee: ValueIteratee<T[keyof T]>

  #### Returns Dictionary<string[]>

### invoke

- invoke(object: any, path: PropertyPath, ...args: any[]): any

- - Defined in node_modules/@types/lodash/common/object.d.ts:2089

  Invokes the method at path of object.

  #### Parameters

  - ##### object: any

    The object to query.

  - ##### path: PropertyPath

    The path of the method to invoke.

  - ##### Rest ...args: any[]

    The arguments to invoke the method with.

  #### Returns any

### keys

- keys(object?: any): string[]

- - Defined in node_modules/@types/lodash/common/object.d.ts:2124

  Creates an array of the own enumerable property names of object.

  Note: Non-object values are coerced to objects. See the ES spec for more details.

  #### Parameters

  - ##### Optional object: any

    The object to query.

  #### Returns string[]

  Returns the array of property names.

### keysIn

- keysIn(object?: any): string[]

- - Defined in node_modules/@types/lodash/common/object.d.ts:2152

  Creates an array of the own and inherited enumerable property names of object.

  Note: Non-object values are coerced to objects.

  #### Parameters

  - ##### Optional object: any

    The object to query.

  #### Returns string[]

  An array of property names.

### mapKeys

- mapKeys<T>(object: List<T> | null | undefined, iteratee?: ListIteratee<T>): Dictionary<T>
- mapKeys<T>(object: T | null | undefined, iteratee?: ObjectIteratee<T>): Dictionary<T[keyof T]>

- - Defined in node_modules/@types/lodash/common/object.d.ts:2180

  The opposite of _.mapValues; this method creates an object with the same values as object and keys generated by running each own enumerable property of object through iteratee.

  #### Type parameters

  - #### T

  #### Parameters

  - ##### object: List<T> | null | undefined

    The object to iterate over.

  - ##### Optional iteratee: ListIteratee<T>

    The function invoked per iteration.

  #### Returns Dictionary<T>

  Returns the new mapped object.

- - Defined in node_modules/@types/lodash/common/object.d.ts:2188
  see

    _.mapKeys

  #### Type parameters

  - #### T: object

  #### Parameters

  - ##### object: T | null | undefined

  - ##### Optional iteratee: ObjectIteratee<T>

  #### Returns Dictionary<T[keyof T]>

### mapValues

- mapValues<TResult>(obj: string | null | undefined, callback: StringIterator<TResult>): NumericDictionary<TResult>
- mapValues<T, TResult>(obj: Dictionary<T> | NumericDictionary<T> | null | undefined, callback: DictionaryIterator<T, TResult>): Dictionary<TResult>
- mapValues<T, TResult>(obj: T | null | undefined, callback: ObjectIterator<T, TResult>): object
- mapValues<T>(obj: Dictionary<T> | NumericDictionary<T> | null | undefined, iteratee: object): Dictionary<boolean>
- mapValues<T>(obj: T | null | undefined, iteratee: object): object
- mapValues<T, TKey>(obj: Dictionary<T> | NumericDictionary<T> | null | undefined, iteratee: TKey): Dictionary<T[TKey]>
- mapValues<T>(obj: Dictionary<T> | NumericDictionary<T> | null | undefined, iteratee: string): Dictionary<any>
- mapValues<T>(obj: T | null | undefined, iteratee: string): object
- mapValues(obj: string | null | undefined): NumericDictionary<string>
- mapValues<T>(obj: Dictionary<T> | NumericDictionary<T> | null | undefined): Dictionary<T>
- mapValues<T>(obj: T): T
- mapValues<T>(obj: T | null | undefined): PartialObject<T>

- - Defined in node_modules/@types/lodash/common/object.d.ts:2242

  Creates an object with the same keys as object and values generated by running each own enumerable property of object through iteratee. The iteratee function is invoked with three arguments: (value, key, object).

  #### Type parameters

  - #### TResult

  #### Parameters

  - ##### obj: string | null | undefined

  - ##### callback: StringIterator<TResult>

  #### Returns NumericDictionary<TResult>

  Returns the new mapped object.

- - Defined in node_modules/@types/lodash/common/object.d.ts:2249
  see

    _.mapValues TODO: This would be better if we had a separate overload for obj: NumericDictionary that returned a NumericDictionary, but TypeScript cannot select overload signatures based on number vs string index key type.

  #### Type parameters

  - #### T

  - #### TResult

  #### Parameters

  - ##### obj: Dictionary<T> | NumericDictionary<T> | null | undefined

  - ##### callback: DictionaryIterator<T, TResult>

  #### Returns Dictionary<TResult>

- - Defined in node_modules/@types/lodash/common/object.d.ts:2254
  see

    _.mapValues

  #### Type parameters

  - #### T: object

  - #### TResult

  #### Parameters

  - ##### obj: T | null | undefined

  - ##### callback: ObjectIterator<T, TResult>

  #### Returns object

- - Defined in node_modules/@types/lodash/common/object.d.ts:2261
  see

    _.mapValues TODO: This would be better if we had a separate overload for obj: NumericDictionary that returned a NumericDictionary, but TypeScript cannot select overload signatures based on number vs string index key type.

  #### Type parameters

  - #### T

  #### Parameters

  - ##### obj: Dictionary<T> | NumericDictionary<T> | null | undefined

  - ##### iteratee: object

  #### Returns Dictionary<boolean>

- - Defined in node_modules/@types/lodash/common/object.d.ts:2266
  see

    _.mapValues

  #### Type parameters

  - #### T: object

  #### Parameters

  - ##### obj: T | null | undefined

  - ##### iteratee: object

  #### Returns object

- - Defined in node_modules/@types/lodash/common/object.d.ts:2273
  see

    _.mapValues TODO: This would be better if we had a separate overload for obj: NumericDictionary that returned a NumericDictionary, but TypeScript cannot select overload signatures based on number vs string index key type.

  #### Type parameters

  - #### T

  - #### TKey: keyof T

  #### Parameters

  - ##### obj: Dictionary<T> | NumericDictionary<T> | null | undefined

  - ##### iteratee: TKey

  #### Returns Dictionary<T[TKey]>

- - Defined in node_modules/@types/lodash/common/object.d.ts:2280
  see

    _.mapValues TODO: This would be better if we had a separate overload for obj: NumericDictionary that returned a NumericDictionary, but TypeScript cannot select overload signatures based on number vs string index key type.

  #### Type parameters

  - #### T

  #### Parameters

  - ##### obj: Dictionary<T> | NumericDictionary<T> | null | undefined

  - ##### iteratee: string

  #### Returns Dictionary<any>

- - Defined in node_modules/@types/lodash/common/object.d.ts:2285
  see

    _.mapValues

  #### Type parameters

  - #### T: object

  #### Parameters

  - ##### obj: T | null | undefined

  - ##### iteratee: string

  #### Returns object

- - Defined in node_modules/@types/lodash/common/object.d.ts:2290
  see

    _.mapValues

  #### Parameters

  - ##### obj: string | null | undefined

  #### Returns NumericDictionary<string>

- - Defined in node_modules/@types/lodash/common/object.d.ts:2297
  see

    _.mapValues TODO: This would be better if we had a separate overload for obj: NumericDictionary that returned a NumericDictionary, but TypeScript cannot select overload signatures based on number vs string index key type.

  #### Type parameters

  - #### T

  #### Parameters

  - ##### obj: Dictionary<T> | NumericDictionary<T> | null | undefined

  #### Returns Dictionary<T>

- - Defined in node_modules/@types/lodash/common/object.d.ts:2302
  see

    _.mapValues

  #### Type parameters

  - #### T: object

  #### Parameters

  - ##### obj: T

  #### Returns T

- - Defined in node_modules/@types/lodash/common/object.d.ts:2307
  see

    _.mapValues

  #### Type parameters

  - #### T: object

  #### Parameters

  - ##### obj: T | null | undefined

  #### Returns PartialObject<T>

### merge

- merge<TObject, TSource>(object: TObject, source: TSource): TObject & TSource
- merge<TObject, TSource1, TSource2>(object: TObject, source1: TSource1, source2: TSource2): TObject & TSource1 & TSource2
- merge<TObject, TSource1, TSource2, TSource3>(object: TObject, source1: TSource1, source2: TSource2, source3: TSource3): TObject & TSource1 & TSource2 & TSource3
- merge<TObject, TSource1, TSource2, TSource3, TSource4>(object: TObject, source1: TSource1, source2: TSource2, source3: TSource3, source4: TSource4): TObject & TSource1 & TSource2 & TSource3 & TSource4
- merge(object: any, ...otherArgs: any[]): any

- - Defined in node_modules/@types/lodash/common/object.d.ts:2532

  Recursively merges own and inherited enumerable properties of source objects into the destination object, skipping source properties that resolve to `undefined`. Array and plain object properties are merged recursively. Other objects and value types are overridden by assignment. Source objects are applied from left to right. Subsequent sources overwrite property assignments of previous sources.

  Note: This method mutates `object`.

  category

    Object

  example

    var users = { 'data': [{ 'user': 'barney' }, { 'user': 'fred' }] };

    var ages = { 'data': [{ 'age': 36 }, { 'age': 40 }] };

    _.merge(users, ages); // => { 'data': [{ 'user': 'barney', 'age': 36 }, { 'user': 'fred', 'age': 40 }] }

  #### Type parameters

  - #### TObject

  - #### TSource

  #### Parameters

  - ##### object: TObject

    The destination object.

  - ##### source: TSource

  #### Returns TObject & TSource

  Returns `object`.

- - Defined in node_modules/@types/lodash/common/object.d.ts:2540
  see

    _.merge

  #### Type parameters

  - #### TObject

  - #### TSource1

  - #### TSource2

  #### Parameters

  - ##### object: TObject

  - ##### source1: TSource1

  - ##### source2: TSource2

  #### Returns TObject & TSource1 & TSource2

- - Defined in node_modules/@types/lodash/common/object.d.ts:2549
  see

    _.merge

  #### Type parameters

  - #### TObject

  - #### TSource1

  - #### TSource2

  - #### TSource3

  #### Parameters

  - ##### object: TObject

  - ##### source1: TSource1

  - ##### source2: TSource2

  - ##### source3: TSource3

  #### Returns TObject & TSource1 & TSource2 & TSource3

- - Defined in node_modules/@types/lodash/common/object.d.ts:2559
  see

    _.merge

  #### Type parameters

  - #### TObject

  - #### TSource1

  - #### TSource2

  - #### TSource3

  - #### TSource4

  #### Parameters

  - ##### object: TObject

  - ##### source1: TSource1

  - ##### source2: TSource2

  - ##### source3: TSource3

  - ##### source4: TSource4

  #### Returns TObject & TSource1 & TSource2 & TSource3 & TSource4

- - Defined in node_modules/@types/lodash/common/object.d.ts:2570
  see

    _.merge

  #### Parameters

  - ##### object: any

  - ##### Rest ...otherArgs: any[]

  #### Returns any

### mergeWith

- mergeWith<TObject, TSource>(object: TObject, source: TSource, customizer: MergeWithCustomizer): TObject & TSource
- mergeWith<TObject, TSource1, TSource2>(object: TObject, source1: TSource1, source2: TSource2, customizer: MergeWithCustomizer): TObject & TSource1 & TSource2
- mergeWith<TObject, TSource1, TSource2, TSource3>(object: TObject, source1: TSource1, source2: TSource2, source3: TSource3, customizer: MergeWithCustomizer): TObject & TSource1 & TSource2 & TSource3
- mergeWith<TObject, TSource1, TSource2, TSource3, TSource4>(object: TObject, source1: TSource1, source2: TSource2, source3: TSource3, source4: TSource4, customizer: MergeWithCustomizer): TObject & TSource1 & TSource2 & TSource3 & TSource4
- mergeWith(object: any, ...otherArgs: any[]): any

- - Defined in node_modules/@types/lodash/common/object.d.ts:2700

  This method is like `_.merge` except that it accepts `customizer` which is invoked to produce the merged values of the destination and source properties. If `customizer` returns `undefined` merging is handled by the method instead. The `customizer` is invoked with seven arguments: (objValue, srcValue, key, object, source, stack).

  category

    Object

  example

    function customizer(objValue, srcValue) { if (_.isArray(objValue)) { return objValue.concat(srcValue); } }

    var object = { 'fruits': ['apple'], 'vegetables': ['beet'] };

    var other = { 'fruits': ['banana'], 'vegetables': ['carrot'] };

    _.merge(object, other, customizer); // => { 'fruits': ['apple', 'banana'], 'vegetables': ['beet', 'carrot'] }

  #### Type parameters

  - #### TObject

  - #### TSource

  #### Parameters

  - ##### object: TObject

    The destination object.

  - ##### source: TSource

  - ##### customizer: MergeWithCustomizer

    The function to customize assigned values.

  #### Returns TObject & TSource

  Returns `object`.

- - Defined in node_modules/@types/lodash/common/object.d.ts:2709
  see

    _.mergeWith

  #### Type parameters

  - #### TObject

  - #### TSource1

  - #### TSource2

  #### Parameters

  - ##### object: TObject

  - ##### source1: TSource1

  - ##### source2: TSource2

  - ##### customizer: MergeWithCustomizer

  #### Returns TObject & TSource1 & TSource2

- - Defined in node_modules/@types/lodash/common/object.d.ts:2719
  see

    _.mergeWith

  #### Type parameters

  - #### TObject

  - #### TSource1

  - #### TSource2

  - #### TSource3

  #### Parameters

  - ##### object: TObject

  - ##### source1: TSource1

  - ##### source2: TSource2

  - ##### source3: TSource3

  - ##### customizer: MergeWithCustomizer

  #### Returns TObject & TSource1 & TSource2 & TSource3

- - Defined in node_modules/@types/lodash/common/object.d.ts:2730
  see

    _.mergeWith

  #### Type parameters

  - #### TObject

  - #### TSource1

  - #### TSource2

  - #### TSource3

  - #### TSource4

  #### Parameters

  - ##### object: TObject

  - ##### source1: TSource1

  - ##### source2: TSource2

  - ##### source3: TSource3

  - ##### source4: TSource4

  - ##### customizer: MergeWithCustomizer

  #### Returns TObject & TSource1 & TSource2 & TSource3 & TSource4

- - Defined in node_modules/@types/lodash/common/object.d.ts:2742
  see

    _.mergeWith

  #### Parameters

  - ##### object: any

  - ##### Rest ...otherArgs: any[]

  #### Returns any

### omit

- omit<T>(object: T | null | undefined, ...paths: Array<Many<PropertyName>>): T
- omit<T, K>(object: T | null | undefined, ...paths: Array<Many<K>>): Omit<T, K>
- omit<T>(object: T | null | undefined, ...paths: Array<Many<PropertyName>>): PartialObject<T>

- - Defined in node_modules/@types/lodash/common/object.d.ts:2861

  The opposite of `_.pick`; this method creates an object composed of the own and inherited enumerable properties of `object` that are not omitted.

  category

    Object

  example

    var object = { 'a': 1, 'b': '2', 'c': 3 };

    _.omit(object, ['a', 'c']); // => { 'b': '2' }

  #### Type parameters

  - #### T: AnyKindOfDictionary

  #### Parameters

  - ##### object: T | null | undefined

    The source object.

  - ##### Rest ...paths: Array<Many<PropertyName>>

  #### Returns T

  Returns the new object.

- - Defined in node_modules/@types/lodash/common/object.d.ts:2869
  see

    _.omit

  #### Type parameters

  - #### T: object

  - #### K: keyof T

  #### Parameters

  - ##### object: T | null | undefined

  - ##### Rest ...paths: Array<Many<K>>

  #### Returns Omit<T, K>

- - Defined in node_modules/@types/lodash/common/object.d.ts:2877
  see

    _.omit

  #### Type parameters

  - #### T: object

  #### Parameters

  - ##### object: T | null | undefined

  - ##### Rest ...paths: Array<Many<PropertyName>>

  #### Returns PartialObject<T>

### omitBy

- omitBy<T>(object: Dictionary<T> | null | undefined, predicate?: ValueKeyIteratee<T>): Dictionary<T>
- omitBy<T>(object: NumericDictionary<T> | null | undefined, predicate?: ValueKeyIteratee<T>): NumericDictionary<T>
- omitBy<T>(object: T | null | undefined, predicate: ValueKeyIteratee<T[keyof T]>): PartialObject<T>

- - Defined in node_modules/@types/lodash/common/object.d.ts:2954

  The opposite of `_.pickBy`; this method creates an object composed of the own and inherited enumerable properties of `object` that `predicate` doesn't return truthy for.

  category

    Object

  example

    var object = { 'a': 1, 'b': '2', 'c': 3 };

    _.omitBy(object, _.isNumber); // => { 'b': '2' }

  #### Type parameters

  - #### T

  #### Parameters

  - ##### object: Dictionary<T> | null | undefined

    The source object.

  - ##### Optional predicate: ValueKeyIteratee<T>

  #### Returns Dictionary<T>

  Returns the new object.

- - Defined in node_modules/@types/lodash/common/object.d.ts:2962
  see

    _.omitBy

  #### Type parameters

  - #### T

  #### Parameters

  - ##### object: NumericDictionary<T> | null | undefined

  - ##### Optional predicate: ValueKeyIteratee<T>

  #### Returns NumericDictionary<T>

- - Defined in node_modules/@types/lodash/common/object.d.ts:2970
  see

    _.omitBy

  #### Type parameters

  - #### T: object

  #### Parameters

  - ##### object: T | null | undefined

  - ##### predicate: ValueKeyIteratee<T[keyof T]>

  #### Returns PartialObject<T>

### pick

- pick<T, U>(object: T, ...props: Array<Many<U>>): Pick<T, U>
- pick<T>(object: T | null | undefined, ...props: PropertyPath[]): PartialDeep<T>

- - Defined in node_modules/@types/lodash/common/object.d.ts:3046

  Creates an object composed of the picked `object` properties.

  category

    Object

  example

    var object = { 'a': 1, 'b': '2', 'c': 3 };

    _.pick(object, ['a', 'c']); // => { 'a': 1, 'c': 3 }

  #### Type parameters

  - #### T: object

  - #### U: keyof T

  #### Parameters

  - ##### object: T

    The source object.

  - ##### Rest ...props: Array<Many<U>>

  #### Returns Pick<T, U>

  Returns the new object.

- - Defined in node_modules/@types/lodash/common/object.d.ts:3054
  see

    _.pick

  #### Type parameters

  - #### T

  #### Parameters

  - ##### object: T | null | undefined

  - ##### Rest ...props: PropertyPath[]

  #### Returns PartialDeep<T>

### pickBy

- pickBy<T, S>(object: Dictionary<T> | null | undefined, predicate: ValueKeyIterateeTypeGuard<T, S>): Dictionary<S>
- pickBy<T, S>(object: NumericDictionary<T> | null | undefined, predicate: ValueKeyIterateeTypeGuard<T, S>): NumericDictionary<S>
- pickBy<T>(object: Dictionary<T> | null | undefined, predicate?: ValueKeyIteratee<T>): Dictionary<T>
- pickBy<T>(object: NumericDictionary<T> | null | undefined, predicate?: ValueKeyIteratee<T>): NumericDictionary<T>
- pickBy<T>(object: T | null | undefined, predicate?: ValueKeyIteratee<T[keyof T]>): PartialObject<T>

- - Defined in node_modules/@types/lodash/common/object.d.ts:3114

  Creates an object composed of the `object` properties `predicate` returns truthy for. The predicate is invoked with two arguments: (value, key).

  category

    Object

  example

    var object = { 'a': 1, 'b': '2', 'c': 3 };

    _.pickBy(object, _.isNumber); // => { 'a': 1, 'c': 3 }

  #### Type parameters

  - #### T

  - #### S: T

  #### Parameters

  - ##### object: Dictionary<T> | null | undefined

    The source object.

  - ##### predicate: ValueKeyIterateeTypeGuard<T, S>

  #### Returns Dictionary<S>

  Returns the new object.

- - Defined in node_modules/@types/lodash/common/object.d.ts:3122
  see

    _.pickBy

  #### Type parameters

  - #### T

  - #### S: T

  #### Parameters

  - ##### object: NumericDictionary<T> | null | undefined

  - ##### predicate: ValueKeyIterateeTypeGuard<T, S>

  #### Returns NumericDictionary<S>

- - Defined in node_modules/@types/lodash/common/object.d.ts:3130
  see

    _.pickBy

  #### Type parameters

  - #### T

  #### Parameters

  - ##### object: Dictionary<T> | null | undefined

  - ##### Optional predicate: ValueKeyIteratee<T>

  #### Returns Dictionary<T>

- - Defined in node_modules/@types/lodash/common/object.d.ts:3138
  see

    _.pickBy

  #### Type parameters

  - #### T

  #### Parameters

  - ##### object: NumericDictionary<T> | null | undefined

  - ##### Optional predicate: ValueKeyIteratee<T>

  #### Returns NumericDictionary<T>

- - Defined in node_modules/@types/lodash/common/object.d.ts:3146
  see

    _.pickBy

  #### Type parameters

  - #### T: object

  #### Parameters

  - ##### object: T | null | undefined

  - ##### Optional predicate: ValueKeyIteratee<T[keyof T]>

  #### Returns PartialObject<T>

### result

- result<TResult>(object: any, path: PropertyPath, defaultValue?: TResult | function): TResult

- - Defined in node_modules/@types/lodash/common/object.d.ts:3248

  This method is like _.get except that if the resolved value is a function it’s invoked with the this binding of its parent object and its result is returned.

  #### Type parameters

  - #### TResult

  #### Parameters

  - ##### object: any

    The object to query.

  - ##### path: PropertyPath

    The path of the property to resolve.

  - ##### Optional defaultValue: TResult | function

    The value returned if the resolved value is undefined.

  #### Returns TResult

  Returns the resolved value.

### set

- set<T>(object: T, path: PropertyPath, value: any): T
- set<TResult>(object: object, path: PropertyPath, value: any): TResult

- - Defined in node_modules/@types/lodash/common/object.d.ts:3288

  Sets the value at path of object. If a portion of path doesn’t exist it’s created. Arrays are created for missing index properties while objects are created for all other missing properties. Use _.setWith to customize path creation.

  #### Type parameters

  - #### T: object

  #### Parameters

  - ##### object: T

    The object to modify.

  - ##### path: PropertyPath

    The path of the property to set.

  - ##### value: any

    The value to set.

  #### Returns T

  Returns object.

- - Defined in node_modules/@types/lodash/common/object.d.ts:3297
  see

    _.set

  #### Type parameters

  - #### TResult

  #### Parameters

  - ##### object: object

  - ##### path: PropertyPath

  - ##### value: any

  #### Returns TResult

### setWith

- setWith<T>(object: T, path: PropertyPath, value: any, customizer?: SetWithCustomizer<T>): T
- setWith<T, TResult>(object: T, path: PropertyPath, value: any, customizer?: SetWithCustomizer<T>): TResult

- - Defined in node_modules/@types/lodash/common/object.d.ts:3356

  This method is like _.set except that it accepts customizer which is invoked to produce the objects of path. If customizer returns undefined path creation is handled by the method instead. The customizer is invoked with three arguments: (nsValue, key, nsObject).

  #### Type parameters

  - #### T: object

  #### Parameters

  - ##### object: T

    The object to modify.

  - ##### path: PropertyPath

    The path of the property to set.

  - ##### value: any

    The value to set.

  - ##### Optional customizer: SetWithCustomizer<T>

    The function to customize assigned values.

  #### Returns T

  Returns object.

- - Defined in node_modules/@types/lodash/common/object.d.ts:3363

  #### Type parameters

  - #### T: object

  - #### TResult

  #### Parameters

  - ##### object: T

  - ##### path: PropertyPath

  - ##### value: any

  - ##### Optional customizer: SetWithCustomizer<T>

  #### Returns TResult

### toPairs

- toPairs<T>(object?: Dictionary<T> | NumericDictionary<T>): Array<[string, T]>
- toPairs(object?: undefined | object): Array<[string, any]>

- - Defined in node_modules/@types/lodash/common/object.d.ts:3420

  Creates an array of own enumerable key-value pairs for object.

  #### Type parameters

  - #### T

  #### Parameters

  - ##### Optional object: Dictionary<T> | NumericDictionary<T>

    The object to query.

  #### Returns Array<[string, T]>

  Returns the new array of key-value pairs.

- - Defined in node_modules/@types/lodash/common/object.d.ts:3425
  see

    _.toPairs

  #### Parameters

  - ##### Optional object: undefined | object

  #### Returns Array<[string, any]>

### toPairsIn

- toPairsIn<T>(object?: Dictionary<T> | NumericDictionary<T>): Array<[string, T]>
- toPairsIn(object?: undefined | object): Array<[string, any]>

- - Defined in node_modules/@types/lodash/common/object.d.ts:3461

  Creates an array of own and inherited enumerable key-value pairs for object.

  #### Type parameters

  - #### T

  #### Parameters

  - ##### Optional object: Dictionary<T> | NumericDictionary<T>

    The object to query.

  #### Returns Array<[string, T]>

  Returns the new array of key-value pairs.

- - Defined in node_modules/@types/lodash/common/object.d.ts:3466
  see

    _.toPairsIn

  #### Parameters

  - ##### Optional object: undefined | object

  #### Returns Array<[string, any]>

### transform

- transform<T, TResult>(object: T[], iteratee: MemoVoidArrayIterator<T, TResult[]>, accumulator?: TResult[]): TResult[]
- transform<T, TResult>(object: T[], iteratee: MemoVoidArrayIterator<T, Dictionary<TResult>>, accumulator: Dictionary<TResult>): Dictionary<TResult>
- transform<T, TResult>(object: Dictionary<T>, iteratee: MemoVoidDictionaryIterator<T, Dictionary<TResult>>, accumulator?: Dictionary<TResult>): Dictionary<TResult>
- transform<T, TResult>(object: Dictionary<T>, iteratee: MemoVoidDictionaryIterator<T, TResult[]>, accumulator: TResult[]): TResult[]
- transform(object: any[]): any[]
- transform(object: object): Dictionary<any>

- - Defined in node_modules/@types/lodash/common/object.d.ts:3507

  An alternative to _.reduce; this method transforms object to a new accumulator object which is the result of running each of its own enumerable properties through iteratee, with each invocation potentially mutating the accumulator object. The iteratee is invoked with four arguments: (accumulator, value, key, object). Iteratee functions may exit iteration early by explicitly returning false.

  #### Type parameters

  - #### T

  - #### TResult

  #### Parameters

  - ##### object: T[]

    The object to iterate over.

  - ##### iteratee: MemoVoidArrayIterator<T, TResult[]>

    The function invoked per iteration.

  - ##### Optional accumulator: TResult[]

    The custom accumulator value.

  #### Returns TResult[]

  Returns the accumulated value.

- - Defined in node_modules/@types/lodash/common/object.d.ts:3516
  see

    _.transform

  #### Type parameters

  - #### T

  - #### TResult

  #### Parameters

  - ##### object: T[]

  - ##### iteratee: MemoVoidArrayIterator<T, Dictionary<TResult>>

  - ##### accumulator: Dictionary<TResult>

  #### Returns Dictionary<TResult>

- - Defined in node_modules/@types/lodash/common/object.d.ts:3525
  see

    _.transform

  #### Type parameters

  - #### T

  - #### TResult

  #### Parameters

  - ##### object: Dictionary<T>

  - ##### iteratee: MemoVoidDictionaryIterator<T, Dictionary<TResult>>

  - ##### Optional accumulator: Dictionary<TResult>

  #### Returns Dictionary<TResult>

- - Defined in node_modules/@types/lodash/common/object.d.ts:3534
  see

    _.transform

  #### Type parameters

  - #### T

  - #### TResult

  #### Parameters

  - ##### object: Dictionary<T>

  - ##### iteratee: MemoVoidDictionaryIterator<T, TResult[]>

  - ##### accumulator: TResult[]

  #### Returns TResult[]

- - Defined in node_modules/@types/lodash/common/object.d.ts:3543
  see

    _.transform

  #### Parameters

  - ##### object: any[]

  #### Returns any[]

- - Defined in node_modules/@types/lodash/common/object.d.ts:3550
  see

    _.transform

  #### Parameters

  - ##### object: object

  #### Returns Dictionary<any>

### unset

- unset(object: any, path: PropertyPath): boolean

- - Defined in node_modules/@types/lodash/common/object.d.ts:3667

  Removes the property at path of object.

  Note: This method mutates object.

  #### Parameters

  - ##### object: any

    The object to modify.

  - ##### path: PropertyPath

    The path of the property to unset.

  #### Returns boolean

  Returns true if the property is deleted, else false.

### update

- update(object: object, path: PropertyPath, updater: function): any

- - Defined in node_modules/@types/lodash/common/object.d.ts:3699

  This method is like _.set except that accepts updater to produce the value to set. Use _.updateWith to customize path creation. The updater is invoked with one argument: (value).

  #### Parameters

  - ##### object: object

    The object to modify.

  - ##### path: PropertyPath

    The path of the property to set.

  - ##### updater: function

    The function to produce the updated value.

    - - (value: any): any

      - #### Parameters

        - ##### value: any

        #### Returns any

  Returns object.

### updateWith

- updateWith<T>(object: T, path: PropertyPath, updater: function, customizer?: SetWithCustomizer<T>): T
- updateWith<T, TResult>(object: T, path: PropertyPath, updater: function, customizer?: SetWithCustomizer<T>): TResult

- - Defined in node_modules/@types/lodash/common/object.d.ts:3751

  This method is like `_.update` except that it accepts `customizer` which is invoked to produce the objects of `path`. If `customizer` returns `undefined` path creation is handled by the method instead. The `customizer` is invoked with three arguments: (nsValue, key, nsObject).

  Note: This method mutates `object`.

  since

    4.6.0

  category

    Object

  example

    var object = {};

    _.updateWith(object, '[0][1]', _.constant('a'), Object); // => { '0': { '1': 'a' } }

  #### Type parameters

  - #### T: object

  #### Parameters

  - ##### object: T

    The object to modify.

  - ##### path: PropertyPath

    The path of the property to set.

  - ##### updater: function

    The function to produce the updated value.

    - - (oldValue: any): any

      - #### Parameters

        - ##### oldValue: any

        #### Returns any

  - ##### Optional customizer: SetWithCustomizer<T>

  #### Returns T

  Returns `object`.

- - Defined in node_modules/@types/lodash/common/object.d.ts:3761
  see

    _.updateWith

  #### Type parameters

  - #### T: object

  - #### TResult

  #### Parameters

  - ##### object: T

  - ##### path: PropertyPath

  - ##### updater: function

    - - (oldValue: any): any

      - #### Parameters

        - ##### oldValue: any

        #### Returns any

  - ##### Optional customizer: SetWithCustomizer<T>

  #### Returns TResult

### values

- values<T>(object: Dictionary<T> | NumericDictionary<T> | List<T> | null | undefined): T[]
- values<T>(object: T | null | undefined): Array<T[keyof T]>
- values(object: any): any[]

- - Defined in node_modules/@types/lodash/common/object.d.ts:3818

  Creates an array of the own enumerable property values of object.

  #### Type parameters

  - #### T

  #### Parameters

  - ##### object: Dictionary<T> | NumericDictionary<T> | List<T> | null | undefined

    The object to query.

  #### Returns T[]

  Returns an array of property values.

- - Defined in node_modules/@types/lodash/common/object.d.ts:3823
  see

    _.values

  #### Type parameters

  - #### T: object

  #### Parameters

  - ##### object: T | null | undefined

  #### Returns Array<T[keyof T]>

- - Defined in node_modules/@types/lodash/common/object.d.ts:3828
  see

    _.values

  #### Parameters

  - ##### object: any

  #### Returns any[]

### valuesIn

- valuesIn<T>(object: Dictionary<T> | NumericDictionary<T> | List<T> | null | undefined): T[]
- valuesIn<T>(object: T | null | undefined): Array<T[keyof T]>

- - Defined in node_modules/@types/lodash/common/object.d.ts:3874

  Creates an array of the own and inherited enumerable property values of object.

  #### Type parameters

  - #### T

  #### Parameters

  - ##### object: Dictionary<T> | NumericDictionary<T> | List<T> | null | undefined

    The object to query.

  #### Returns T[]

  Returns the array of property values.

- - Defined in node_modules/@types/lodash/common/object.d.ts:3879
  see

    _.valuesIn

  #### Type parameters

  - #### T: object

  #### Parameters

  - ##### object: T | null | undefined

  #### Returns Array<T[keyof T]>

Generated using TypeDoc